Module java.compiler
Package javax.lang.model.util

# Class ElementKindVisitor8<R,​P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,​P>
javax.lang.model.util.SimpleElementVisitor6<R,​P>
javax.lang.model.util.ElementKindVisitor6<R,​P>
javax.lang.model.util.ElementKindVisitor7<R,​P>
javax.lang.model.util.ElementKindVisitor8<R,​P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,​P>`

Direct Known Subclasses:
  `ElementKindVisitor9`

@SupportedSourceVersion(RELEASE_8) public class ElementKindVisitor8<R,​P> extends ElementKindVisitor7<R,​P>
A visitor of program elements based on their kind with default behavior appropriate for the `RELEASE_8` source version. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  1.8
See Also:
  Compatibility note for subclasses, `ElementKindVisitor6`, `ElementKindVisitor7`, `ElementKindVisitor9`, `ElementKindVisitor14`

## Field Summary

### Fields declared in class javax.lang.model.util.SimpleElementVisitor6

`DEFAULT_VALUE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ElementKindVisitor8()`
Constructor for concrete subclasses; uses `null` for the default value.
`protected`
`ElementKindVisitor8​(R defaultValue)`
Constructor for concrete subclasses; uses the argument for the default value.

## Method Summary

### Methods declared in class javax.lang.model.util.ElementKindVisitor7

`visitVariableAsResourceVariable`

### Methods declared in class javax.lang.model.util.ElementKindVisitor6

`visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeAsRecord, visitTypeParameter, visitVariable, visitVariableAsBindingVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`

### Methods declared in class javax.lang.model.util.SimpleElementVisitor6

`defaultAction`

### Methods declared in class javax.lang.model.util.AbstractElementVisitor6

`visit, visit, visitModule, visitRecordComponent, visitUnknown`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ElementKindVisitor8

protected ElementKindVisitor8()
Constructor for concrete subclasses; uses `null` for the default value.

### ElementKindVisitor8

protected ElementKindVisitor8​(R defaultValue)
Constructor for concrete subclasses; uses the argument for the default value.

Parameters:
  `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`